

print("loading BloodMod")


import Bladex
import math
import InitDataField
import string
import whrandom


try:
	os.remove("..\\..\\Scripts\\bloodmod.pyc")
	print("bloodmod.pyc removed")	
except:
	pass


try:
	os.remove("..\\..\\Lib\\blood.pyc")
	print("blood.pyc removed")	
except:
	pass



import Blood
import bloodmodcfg

BLEEDING_TIME = string.atof (bloodmodcfg.BLEEDINGTIME)

if (bloodmodcfg.BLEEDINGAMOUNT == "NORMAL"):  BLOOD_AMOUNT = 512
if (bloodmodcfg.BLEEDINGAMOUNT == "HIGH"):    BLOOD_AMOUNT = 1024
if (bloodmodcfg.BLEEDINGAMOUNT == "MAXIMUM"): BLOOD_AMOUNT = 2048

if (bloodmodcfg.FOUNTAINS == "NORMAL"):  FOUNTAINS = 1
if (bloodmodcfg.FOUNTAINS == "HIGH"):    FOUNTAINS = 2
if (bloodmodcfg.FOUNTAINS == "MAXIMUM"): FOUNTAINS = 3

	

Evaporation = 0
AfterCreateBlood = None



def SetEvap():

	global Evaporation

	if (bloodmodcfg.EVAPORATION == 1): 
		Blood.Evaporation = 1
		Evaporation = 1
		print("BloodMod: setting BloodMod evaporation to 1")

	if (bloodmodcfg.EVAPORATION == 0): 
		Blood.Evaporation = 0
		Evaporation = 0
		print("BloodMod: setting evaporation to 0")



def SetMutil():

	Bladex.SetBloodLevel(1)
	Bladex.SetMutilationLevel(1)
	print("BloodMod: setting BloodLevel to 1")
	print("BloodMod: setting Mutilation to 1")


Bladex.AddScheduledFunc(Bladex.GetTime()+1.1, SetMutil, () )
Bladex.AddScheduledFunc(Bladex.GetTime()+1.2, SetEvap,  () )





def BloodPrtlHit(prtl_name,hit_entity,x,y,z,vx,vy,vz,wcx,wcy,wcz,wdx,wdy,wdz):
	global Evaporation
	p = Bladex.CreateEntity("BloodPool","Entity Pool",x,y,z)

	#p.Scale = 2.0 #IronLord #it has no effect :-(

	c1 = whrandom.randint(0, 255)
	c2 = whrandom.randint(0, 255)
	c3 = whrandom.randint(0, 255)

	c4 = whrandom.randint(0, 255)
	c5 = whrandom.randint(0, 255)
	c6 = whrandom.randint(0, 255)

	global BLOODCOLOUR

	if (bloodmodcfg.BLOODCOLOUR == "BLACK"):	

		p.Color     = 255,255,255
		p.DeepColor = 1,1,1


	if (bloodmodcfg.BLOODCOLOUR == "RANDOM"):

		c1 = whrandom.randint(0, 255)
		c2 = whrandom.randint(0, 255)
		c3 = whrandom.randint(0, 255)	

		c3 = whrandom.randint(0, 255)
		c4 = whrandom.randint(0, 255)
		c5 = whrandom.randint(0, 255)

		p.Color     = c1,c2,c3
		p.DeepColor = c3,c4,c5 #255,255,255

	

	prtl= Bladex.GetEntity(prtl_name);
	try:
		if(prtl.Data.evaporation):
			p.DeathTime = Bladex.GetTime()+20.0
		elif Evaporation:
			p.DeathTime = Bladex.GetTime()+50.0
	except:
		if Evaporation:
			p.DeathTime = Bladex.GetTime()+50.0
			
	if AfterCreateBlood:
		AfterCreateBlood(x,y,z)



Blood.BloodPrtlHit = BloodPrtlHit



def GreenBloodPrtlHit(prtl_name,hit_entity,x,y,z,vx,vy,vz,wcx,wcy,wcz,wdx,wdy,wdz):
	global Evaporation
	p=Bladex.CreateEntity("BloodPool","Entity Pool",x,y,z)


	global BLOODCOLOUR

	if (bloodmodcfg.BLOODCOLOUR == "NORMAL"):

		p.Color = (96,192,96)
		p.DeepColor = (64,128,64)


	if (bloodmodcfg.BLOODCOLOUR == "BLACK"):	

		p.Color     = 255,255,255
		p.DeepColor = 1,1,1


	if (bloodmodcfg.BLOODCOLOUR == "RANDOM"):

		c1 = whrandom.randint(0, 255)
		c2 = whrandom.randint(0, 255)
		c3 = whrandom.randint(0, 255)	

		c3 = whrandom.randint(0, 255)
		c4 = whrandom.randint(0, 255)
		c5 = whrandom.randint(0, 255)

		p.Color     = c1,c2,c3
		p.DeepColor = c3,c4,c5 #255,255,255





	if Evaporation:
		p.DeathTime = Bladex.GetTime()+50.0
		
	# Generate a smoke effect
	smoke=Bladex.CreateEntity("FuegoVerde", "Entity Particle System D1", x, y, z)
	smoke.ParticleType="VenomSmoke"
	smoke.YGravity=-100.0
	smoke.Friction=0.05
	smoke.PPS=8
	smoke.Velocity=0.0, -800.0, 0.0
	smoke.RandomVelocity=5.0
	smoke.DeathTime=Bladex.GetTime()+1.5


Blood.GreenBloodPrtlHit = GreenBloodPrtlHit

def GreyBloodPrtlHit(prtl_name,hit_entity,x,y,z,vx,vy,vz,wcx,wcy,wcz,wdx,wdy,wdz):	
	global Evaporation
	p=Bladex.CreateEntity("BloodPool","Entity Pool",x,y,z)


	global BLOODCOLOUR

	if (bloodmodcfg.BLOODCOLOUR == "NORMAL"):
	
		p.Color = (96,96,96)
		p.DeepColor = (80,80,80)
	

	if (bloodmodcfg.BLOODCOLOUR == "BLACK"):	

		p.Color     = 255,255,255
		p.DeepColor = 1,1,1


	if (bloodmodcfg.BLOODCOLOUR == "RANDOM"):

		c1 = whrandom.randint(0, 255)
		c2 = whrandom.randint(0, 255)
		c3 = whrandom.randint(0, 255)	

		c3 = whrandom.randint(0, 255)
		c4 = whrandom.randint(0, 255)
		c5 = whrandom.randint(0, 255)

		p.Color     = c1,c2,c3
		p.DeepColor = c3,c4,c5 #255,255,255
	


	if Evaporation:
		p.DeathTime = Bladex.GetTime()+50.0


Blood.GreyBloodPrtlHit = GreyBloodPrtlHit

def BleedFunc(blood_name,end_time,period):
	blood=Bladex.GetEntity(blood_name)
	if(blood):
		prtl=blood.GetParticleEntity()
		InitDataField.Initialise(prtl)
		prtl.Data.evaporation=0
		if blood.ParticleType=="GreenBlood":
			prtl.HitFunc=GreenBloodPrtlHit
		elif blood.ParticleType=="GreyBlood":
			prtl.HitFunc=GreyBloodPrtlHit
		else:						
			prtl.HitFunc=BloodPrtlHit
			
		if(Bladex.GetTime()<end_time):
			Bladex.AddScheduledFunc(Bladex.GetTime()+period,BleedFunc,(blood_name,end_time,period),blood.Name+" BleedFunc")


Blood.BleedFunc = BleedFunc



## BASIC BLOOD FUNCTION EDITED BY TEMPLAR GFX

AGE_Number=0

def Bleed(objname,start_time,end_time,period,x=0.0,y=0.0,z=0.0,vx=0,vy=0,vz=0,ParticleType="Blood"):
	global AGE_Number
	AGE_Number=AGE_Number+1
	blood=Bladex.CreateEntity("bleed_AGE_"+str(AGE_Number),"Entity Particle System D1",x,y,z)

	# blood.Color can not be used here :-(
	
	blood.ParticleType=ParticleType
	blood.YGravity	= 9800.0
	blood.Friction	= 0.075

	global BLOOD_AMOUNT
	blood.PPS	= BLOOD_AMOUNT 		# 2048 			## Number of blood particles per second
	
	blood.DeathTime = Bladex.GetTime() + 10 # end_time+1.0/2.0; 	#IronLord #end_time+1.0/60.0;  
	blood.Velocity=vx,vy,vz
	Bladex.GetEntity(objname).Link(blood)
	Bladex.AddScheduledFunc(start_time,BleedFunc,(blood.Name,end_time,period),blood.Name+" BleedFunc")



Blood.Bleed = Bleed


def PersonBleed(per,start_time,end_time,period,x=0.0,y=0.0,z=0.0,vx=0,vy=0,vz=0,node=0):
	global AGE_Number
	if(node<0):
		print("invalid node")
		return

	AGE_Number=AGE_Number+1
	blood=Bladex.CreateEntity("bleed_AGE_"+str(AGE_Number),"Entity Particle System D1",x,y,z)
	if per.Kind=="Spidersmall":
		blood.ParticleType="GreenBlood"
	elif per.Kind=="Lich":
		blood.ParticleType="GreyBlood"

	else:				
		blood.ParticleType="Blood"
	blood.YGravity	       = 9800.0
	blood.Friction	       = 0.075
	
	global BLOOD_AMOUNT
	blood.PPS	       = BLOOD_AMOUNT #2048  		   # number of blood particles per second

	global BLEEDING_TIME				
	blood.DeathTime	       = Bladex.GetTime() + BLEEDING_TIME  # end_time+15.0/60.0;# amount of time to emmit blood particles (in seconds)
	
	blood.Velocity	       = vx,vy,vz
	blood.RandomVelocity   = 24.0 # 12 			   # Random velocity added to make blood stream less of a squirt and more gush
	blood.RandomVelocity_V = 24.0 # 12 			   # The bigger the number on these two, the more spead out the fountain will be! 
	per.LinkToNode(blood,node)
	Bladex.AddScheduledFunc(start_time,BleedFunc,(blood.Name,end_time,period),blood.Name+" BleedFunc")
	
	#Bladex.AddScheduledFunc(start_time,BleedFunc,(blood.Name,end_time,period),blood.Name+" BleedFunc")
	#Bladex.AddScheduledFunc(start_time,BleedFunc,(blood.Name,end_time,period),blood.Name+" BleedFunc")



Blood.PersonBleed = PersonBleed



SparkEntities     = ["Golem_metal","ChaosKnight"]
DustDeathEntities = ["Skeleton","Lich","Golem_stone","Golem_clay","Golem_lava","Knight_Zombie"]+SparkEntities

def Mutilate(pj_name,obj_name,x,y,z,nx,ny,nz,node):
	global DustDeathEntities
	global SparkEntities
	
	vx=nx*2000.0
	vy=ny*2000.0
	vz=nz*2000.0
	per= Bladex.GetEntity(pj_name)
	if (per.Kind in DustDeathEntities) or (Bladex.GetBloodLevel()==0):
		return
	if per.Kind=="Spidersmall":
		Bleed(obj_name,Bladex.GetTime()+0.0,Bladex.GetTime()+1.0,0.2,x,y,z,vx,vy,vz,"GreenBlood")
	elif per.Kind=="Lich":
		Bleed(obj_name,Bladex.GetTime()+0.0,Bladex.GetTime()+1.0,0.2,x,y,z,vx,vy,vz,"GreyBlood")
	else:					
		Bleed(obj_name,Bladex.GetTime()+0.0,Bladex.GetTime()+1.0,0.2,x,y,z,vx,vy,vz)

		#Bleed(obj_name,Bladex.GetTime()+1.0,Bladex.GetTime()+2.0,0.2,x+0.1,y,z,vx,vy,vz)

	x,y,z=Bladex.GetEntity(obj_name).Rel2AbsPoint(x,y,z)

	global FOUNTAINS
	for i in range(FOUNTAINS):
		PersonBleed(per,Bladex.GetTime()+0.0,Bladex.GetTime()+1.5,0.125,x,y,z,-2.0*vx,-2.0*vy,-2.0*vz,node)
	


Blood.Mutilate = Mutilate




def BleedingImpact(entity, x, y, z, ImpX, ImpY, ImpZ, weapon_entity,WeaponCx, WeaponCy, WeaponCz,WeaponDx, WeaponDy, WeaponDz):
	global AGE_Number
	global DustDeathEntities
	global SparkEntities
	
	AGE_Number=AGE_Number+1	

	if (entity.Kind in DustDeathEntities) or (Bladex.GetBloodLevel()==0):
		
		dust=Bladex.CreateEntity("dust_AGE_"+str(AGE_Number),"Entity Particle System D1", x, y, z)
		if entity.Kind == "Golem_clay":
			dust.ParticleType="ShitSmoke"
			dust.Time2Live=63
			dust.PPS=60
			dust.RandomVelocity=30.0
		elif entity.Kind == "Golem_lava":
			dust.ParticleType="LargeFire"
			dust.Time2Live=31
			dust.PPS=60
			dust.RandomVelocity=30.0
		elif entity.Kind in SparkEntities:
			dust.ParticleType="Splinter"
			dust.Time2Live=16
			dust.PPS=128
			dust.RandomVelocity=50.0
		else:
			dust.ParticleType="MediumDust"
			dust.Time2Live=63
			dust.PPS=60
			dust.RandomVelocity=30.0
			
		dust.YGravity=0.0
		dust.Friction=0.1
		dust.Velocity=0.0, 0.0, 0.0
		
		dust.DeathTime=Bladex.GetTime()+4.0/60.0
	
	else:
		time=Bladex.GetTime()
		
		if (weapon_entity):
			stickblood=Bladex.CreateEntity("stickbleed_AGE_"+str(AGE_Number),"Entity Particle System D2", WeaponCx, WeaponCy, WeaponCz)
			stickblood.D=WeaponDx, WeaponDy, WeaponDz
			stickblood.YGravity 	= 9800.0
			stickblood.Friction	= 0.15
			stickblood.Friction2	= 0.0
			stickblood.DeathTime	= time + 0.6
			
			stickblood.RandomVelocity=100.0/60
			stickblood.RandomVelocity_V=100.0/60
			stickblood.Time2Live   = 26.0			## Maybe not necessary
			stickblood.Time2Live_V = 5.0  #IronLord #6 	## Increases amount of time that blood comes off weapon (very small changes required)
			
			global BLOOD_AMOUNT
			stickblood.PPS	       = 1024 #BLOOD_AMOUNT 	## Amount of blood particles per second to come off weapon
			
			weapon_entity.Link(stickblood)
			weapon_entity.Link(stickblood)
			weapon_entity.Link(stickblood)
		else:
			stickblood=None
		
		
		blood=Bladex.CreateEntity("bleed_AGE_"+str(AGE_Number),"Entity Particle System D1", x, y, z)
		blood.YGravity=9800.0
		blood.Friction=0.075
		blood.PPS=2048
		blood.DeathTime=time+10.0/50.0;
		blood.Position=x, y, z		
		scale= math.sqrt(ImpX*ImpX+ImpY*ImpY+ImpZ*ImpZ)*5
		if scale==0.0:
			scale=2.0
		scale = -2000.0 / scale # normalized scale by -2000.0
		blood.Velocity=(ImpX*scale), (ImpY*scale)-2000.0, (ImpZ*scale)
		blood.RandomVelocity=15.0
		blood.RandomVelocity_V=10.0
		blood.Time2Live=32
		if stickblood:
			prtl1=stickblood.GetParticleEntity()
			InitDataField.Initialise(prtl1)
			prtl1.Data.evaporation=0
		else:
			prtl1=blood.GetParticleEntity()
			InitDataField.Initialise(prtl1)
			prtl1.Data.evaporation=0
		prtl2=blood.GetParticleEntity()		
		prtl3=blood.GetParticleEntity()		## Each of these creates more streams 
		prtl4=blood.GetParticleEntity()		## for a slashing type effect
		prtl5=blood.GetParticleEntity()		## the more you have the more individual
		# prtl0=blood.GetParticleEntity()		## blood squirts are created off the weapon
		InitDataField.Initialise(prtl2)		## during a swing
		InitDataField.Initialise(prtl3)		## each section below must be changed to
		InitDataField.Initialise(prtl4)		## Have the same number of lines
		prtl2.Data.evaporation=0
		prtl3.Data.evaporation=0
		prtl4.Data.evaporation=0
		prtl5.Data.evaporation=0


		if entity.Kind=="Spidersmall":
			blood.ParticleType="GreenBlood"
			if stickblood:
				stickblood.ParticleType="GreenBlood"
			prtl1.HitFunc=GreenBloodPrtlHit
			prtl2.HitFunc=GreenBloodPrtlHit
			prtl3.HitFunc=GreenBloodPrtlHit
			prtl4.HitFunc=GreenBloodPrtlHit
			prtl5.HitFunc=GreenBloodPrtlHit

		elif entity.Kind=="Lich":
			blood.ParticleType="GreyBlood"
			if stickblood:
				stickblood.ParticleType="GreyBlood"
			prtl1.HitFunc=GreyBloodPrtlHit
			prtl2.HitFunc=GreyBloodPrtlHit
			prtl3.HitFunc=GreyBloodPrtlHit
			prtl4.HitFunc=GreyBloodPrtlHit
			prtl5.HitFunc=GreyBloodPrtlHit

		else:						
			blood.ParticleType="Blood"
			if stickblood:
				stickblood.ParticleType="Blood"
			prtl1.HitFunc=BloodPrtlHit
			prtl2.HitFunc=BloodPrtlHit
			prtl3.HitFunc=BloodPrtlHit
			prtl4.HitFunc=BloodPrtlHit
			prtl5.HitFunc=BloodPrtlHit




# No. Leave the original one! Otherwise problems with grey/pink blood.
# Blood.BleedingImpact = BleedingImpact





print("")
print("EVAPORATION = " +str(Evaporation))
print("BLEEDINGTIME = " +str(BLEEDING_TIME))
print("BLOODAMOUNT = " +str(BLOOD_AMOUNT))
print("FOUNTAINS = " +str(FOUNTAINS))
print("")

print("BloodMod loaded")